import os
import tempfile

from src.aws.s3 import BackupBucket
from src.config.objects import TargetObject
from src.error.exceptions import FileUploadException
from src.system_var.constants import RESBK_JP_NAME, TEMPORARY_FILENAME
from src.util.execute_datetime import ExecuteDateTime
from src.util.logger import logger_instance as logger
from src.writer.file_writer import JsonWriter


def backup_crm_data_process(target_object: TargetObject, sf_object_dict: dict, execute_datetime: ExecuteDateTime):
    """CRM電文データバックアップ処理

    Args:
        target_object (TargetObject): 取得対象オブジェクト名
        sf_object_dict (dict): Salesforceオブジェクトデータ
        execute_datetime (ExecuteDateTime): 実行日時取得インスタンス

    Raises:
        FileUploadException: S3のファイルアップロード失敗
    """

    object_name = target_object.object_name
    # ① CRM電文データバックアップ処理の開始ログを出力する
    logger.info(f'I-RESBK-01 [{object_name}] のCRM電文データバックアップ処理を開始します')

    try:
        file_name = f'{execute_datetime.to_path()}/{target_object.upload_file_name}.json'
        # ② CRMバックアップ保管用バケットに、CRMから取得したJSONの電文データのバックアップを保管する
        _backup_json_file(object_name, file_name, sf_object_dict)
    except Exception as e:
        raise FileUploadException(
            'E-RESBK-01',
            RESBK_JP_NAME,
            f'[{object_name}] 電文データのバックアップに失敗しました ファイル名：[{target_object.upload_file_name}.json] エラー内容:[{e}]'
        )

    # ③ CRM電文データバックアップ処理の終了ログを出力する
    logger.info(f'I-RESBK-03 [{object_name}] のCRM電文データバックアップ処理を終了します')

    # ④ 次の処理へ移行する
    return


def _backup_json_file(object_name: str, file_name: str, sf_object_dict: dict) -> None:

    # 一時ファイル書き込み用の領域を確保
    with tempfile.TemporaryDirectory(prefix=f'{object_name}_') as tmpdir:
        # アップロード用のファイルをローカルに書き出す
        local_file_path = os.path.join(tmpdir, TEMPORARY_FILENAME)
        writer = JsonWriter(local_file_path, sf_object_dict)
        writer.write()
        # ファイルからS3に書き込み
        backup_bucket = BackupBucket()
        backup_bucket.put_response_json(file_name, local_file_path)

    logger.debug(f'D-RESBK-02 [{object_name}] のJSONデータバックアップ 正常終了')

    return
